---
title: ristretto
type: cache
status: stable
---

<!--
     THIS FILE IS AUTOGENERATED!

     To make changes please edit the contents of:
     lib/cache/ristretto.go
-->

import Tabs from '@theme/Tabs';
import TabItem from '@theme/TabItem';


Stores key/value pairs in a map held in the memory-bound
[Ristretto cache](https://github.com/dgraph-io/ristretto).


<Tabs defaultValue="common" values={[
  { label: 'Common', value: 'common', },
  { label: 'Advanced', value: 'advanced', },
]}>

<TabItem value="common">

```yaml
# Common config fields, showing default values
label: ""
ristretto:
  ttl: ""
```

</TabItem>
<TabItem value="advanced">

```yaml
# All config fields, showing default values
label: ""
ristretto:
  ttl: ""
  retries: 0
  retry_period: 50ms
```

</TabItem>
</Tabs>

This cache is more efficient and appropriate for high-volume use cases than the standard memory cache. However, the add command is non-atomic, and therefore this cache is not suitable for deduplication.

This cache type supports setting the TTL individually per key by using the
dynamic `ttl` field of a cache processor or output in order to
override the general TTL configured at the cache resource level.

## Fields

### `ttl`

The TTL of each item as a duration string. After this period an item will be eligible for removal during the next compaction.


Type: `string`  
Default: `""`  

```yaml
# Examples

ttl: 60s

ttl: 5m

ttl: 36h
```

### `retries`

The maximum number of retry attempts to make before abandoning a request.


Type: `int`  
Default: `0`  

### `retry_period`

The duration to wait between retry attempts.


Type: `string`  
Default: `"50ms"`  


